%define vers	4.8.0
Name:           XFree86
Version: 	4.8.0
Release: 	1
Copyright: 	GPL
Summary: 	The basic programs, fonts and docs for an X workstation.
Group: 		Libraries
URL:		http://xfree86.org/
Source0:        %{name}-%{version}.tar.bz2
Source1: 	%{name}.tar.bz2
Patch0: 	xf86site.def-linuxkid.diff
Patch1: 	xfree86.cf-linuxkid.diff
Patch2:		host.def.diff
Patch3:		xf86Version.h.diff
Patch4:		ErrHndlr.c.diff
Patch5:		XlibInt.c.diff
Patch6:		Xlibint.h.diff
Patch7:		vm86.h.diff
BuildRoot: 	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)
Provides:	X11R6 Xft2 libXft2 xft2 libxft2 Xrender xfree86 xpm libxpm xorg Xorg
BuildRequires:	expat-devel freetype2-devel libfreetype2-devel fontconfig-devel libfontconfig-devel utempter-devel
%define		_sysconfdir	/etc/X11
# Strip the crap that's safe to strip, disable build root strip policy.
%define __spec_install_post /usr/lib/rpm/brp-compress

%description
Release %{name} %{vers}:
X-Windows maintains the base structure GUI environment for desktop
managers such as KDE & GNOME or Window Managers Enlightenment, ICE,
etc ... they extend the X-Windows GUI with more nice widget libraries 
such as QT-Troll-Tech or GTK. This release also contains the next 
generation of MESA GL and xft2/fontconfig/freetype2; libraries.

Subsequent versions of %{name} kernel drivers are found in:
xc/programs/Xserver/hw/xfree86/os-support/linux/drm but for
now there in xc/extras/drm/bsd.

CHANGELOG: xc/programs/Xserver/hw/xfree86/CHANGELOG
XFree86.org
cvs -d:pserver:anoncvs:anoncvs@anoncvs.xfree86.org:/cvs co xc

find . -depth -name CVS -exec rm -fr {} \;

%package 	devel
Summary: 	X11R6 static libraries, headers and programming man pages.
Group: 		Development
Provides: 	X11R6-devel Xft2-devel libXft2-devel xft2-devel libxft2-devel Xrender-devel xfree86-devel xpm-devel libxpm-devel xorg-devel Xorg-devel
%description 	devel
For developers or developing X-Windows based applications..

%package 	man
Summary: 	X11R6 manual instruction page(s).
Group: 		Manual
%description 	man
Information 	X-manual.

%package 	drm_src
Summary: 	X11R6 DRM Kernel src(s).
Group: 		Kernel
%description 	drm_src
%{name} %{version} drm source.

#package 	fonts
#Summary: 	X11R6 Type1, True Type, Speedo, etc, fonts for %{name} %{vers}
#Group: 		X11/Fonts
#description 	fonts

%prep
%setup -q -n xc
touch config/cf/host.def
%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0

%build
make World

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install
make DESTDIR=$RPM_BUILD_ROOT install.man
mv $RPM_BUILD_ROOT/usr/X11R6/lib/X11/Cards $RPM_BUILD_ROOT/usr/X11R6/lib/X11/Cards.%{vers}.orig
cp programs/Xserver/hw/xfree86/CHANGELOG $RPM_BUILD_ROOT/usr/X11R6/lib/X11/doc
rm $RPM_BUILD_ROOT/usr/X11R6/include/X11/*.h
cp -p exports/include/X11/*.h $RPM_BUILD_ROOT/usr/X11R6/include/X11
#ln -sf /usr/X11R6/include/freetype2/freetype $RPM_BUILD_ROOT/usr/include/freetype2
#ln -sf /usr/X11R6/include/freetype2/freetype $RPM_BUILD_ROOT/usr/X11R6/include/freetype2/freetype/freetype
#ln -sf /usr/X11R6/include/ft2build.h $RPM_BUILD_ROOT/usr/X11R6/include/freetype2/freetype/ft2build.h
ln -sf /usr/X11R6/include/X11 $RPM_BUILD_ROOT/usr/include/X11
mkdir -p $RPM_BUILD_ROOT/usr/doc
ln -sf /usr/X11R6/lib/X11/doc $RPM_BUILD_ROOT/usr/doc/%{name}-%{vers}
ln -sf xf86cfg $RPM_BUILD_ROOT/usr/X11R6/bin/xorgcfg 
ln -sf xf86config $RPM_BUILD_ROOT/usr/X11R6/bin/xorgconfig
ln -sf xf86cfg $RPM_BUILD_ROOT/usr/X11R6/bin/XF86Setup
ln -sf xf86cfg $RPM_BUILD_ROOT/usr/X11R6/bin/xf86setup
# Note to self: UnComment next line when building true X.org
#ln -sf Xorg $RPM_BUILD_ROOT/usr/X11R6/bin/XFree86
mv $RPM_BUILD_ROOT/usr/X11R6/include/X11/Xft $RPM_BUILD_ROOT/usr/X11R6/include/X11/Xft1
mkdir -p $RPM_BUILD_ROOT/usr/X11R6/include/X11/{PEX5,Xaw,Xft}
#cp lib/PEX5/*.h $RPM_BUILD_ROOT/usr/X11R6/include/X11/PEX5
cp lib/Xaw/*.h $RPM_BUILD_ROOT/usr/X11R6/include/X11/Xaw
cp lib/Xft/*.h $RPM_BUILD_ROOT/usr/X11R6/include/X11/Xft
ln -sf Xmu $RPM_BUILD_ROOT/usr/X11R6/include/X11/XFT
#cd $RPM_BUILD_ROOT/usr/X11R6/include/freetype2/freetype; ln -sf /usr/X11R6/include/fontconfig fontconfig
#cd $RPM_BUILD_ROOT/usr/include; ln -sf /usr/X11R6/include/fontconfig fontconfig

cat > $RPM_BUILD_ROOT/usr/X11R6/lib/pkgconfig/xrender.pc << "EOF"
prefix=/usr/X11R6
exec_prefix=/usr/X11R6/bin
libdir=/usr/X11R6/lib
includedir=/usr/X11R6/include

Name: Xrender
Description: X Render Library
Version: 0.8.3
Cflags: -I${includedir} -I/usr/X11R6/include
Libs: -L${libdir} -lXrender  -L/usr/X11R6/lib -lX11

EOF

cat > $RPM_BUILD_ROOT/usr/X11R6/lib/pkgconfig/xextensions.pc << "EOF"
prefix=/usr/X11R6
exec_prefix=/usr/X11R6/bin
libdir=/usr/X11R6/lib
includedir=/usr/X11R6/include

Name: XExtensions
Description: Sundry X extension headers
Version: 1.0.1
Cflags: -I${includedir}

EOF

mkdir -p $RPM_BUILD_ROOT/usr/lib/pkgconfig; cd $RPM_BUILD_ROOT/usr/lib/pkgconfig
ln -sf ../../X11R6/lib/pkgconfig/*.pc .
cd $RPM_BUILD_ROOT/usr/lib/; ln -sf ../X11R6/lib/lib* .
mkdir -p $RPM_BUILD_ROOT/usr/share/locale; cd $RPM_BUILD_ROOT/usr/share/locale
ln -sf ../../X11R6/lib/X11/locale/compose.dir .
ln -sf ../../X11R6/lib/X11/locale/locale.alias .
ln -sf ../../X11R6/lib/X11/locale/locale.dir .
cd $RPM_BUILD_ROOT/usr/X11R6/lib/X11; ln -sf ../../../share/fonts .
tar xjpf %{SOURCE1} -C $RPM_BUILD_ROOT

strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/codeconv/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/dri/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/drivers/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/drivers/linux/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/extensions/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/fonts/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/input/* 2>/dev/null || :
strip -g -x -X $RPM_BUILD_ROOT/usr/X11R6/lib/modules/linux/* 2>/dev/null || :

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/etc
/usr/X11R6/lib/lib*.so*
/usr/doc
/usr/X11R6/lib/X11
/usr/X11R6/lib/modules
/usr/X11R6/bin
/usr/X11R6/include/X11/bitmaps
/usr/X11R6/include/X11/pixmaps
/usr/lib/lib*.so*
/usr/share
/var

%files devel
%defattr(-,root,root)
/usr/X11R6/lib/*.a
/usr/X11R6/lib/pkgconfig
/usr/X11R6/include/DPS
#/usr/X11R6/include/freetype2
/usr/X11R6/include/GL
#/usr/X11R6/include/fontconfig
/usr/X11R6/include/X11/ICE
/usr/X11R6/include/X11/PEX5
/usr/X11R6/include/X11/PM
/usr/X11R6/include/X11/SM
/usr/X11R6/include/X11/XFT
/usr/X11R6/include/X11/Xaw
/usr/X11R6/include/X11/Xcursor
/usr/X11R6/include/X11/Xft
/usr/X11R6/include/X11/Xft1
/usr/X11R6/include/X11/Xmu
#/usr/X11R6/include/X11/Xprint*
/usr/X11R6/include/X11/extensions
/usr/X11R6/include/X11/fonts
/usr/X11R6/include/X11/*.h
#/usr/X11R6/include/*.h
/usr/lib/lib*.a
/usr/lib/pkgconfig
/usr/include

%files man
%defattr(-,root,root)
/usr/X11R6/man

%files drm_src
%defattr(-,root,root)
/usr/X11R6/src

#files fonts
#defattr(-,root,root)
#/fonts
